--- ConsoleKit-0.4.1/src/ck-manager.c.1	2010-09-06 17:41:32.942210394 +0800
+++ ConsoleKit-0.4.1/src/ck-manager.c	2010-09-06 17:41:56.671280731 +0800
@@ -45,9 +45,14 @@
 #include <secdb.h>
 #endif
 
+#ifndef HAVE_STRVERSCMP
+#include "strverscmp.h"
+#endif
+
 #include "ck-manager.h"
 #include "ck-manager-glue.h"
 #include "ck-seat.h"
+#include "ck-display-template.h"
 #include "ck-session-leader.h"
 #include "ck-session.h"
 #include "ck-marshal.h"
@@ -57,12 +62,19 @@
 
 #define CK_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CK_TYPE_MANAGER, CkManagerPrivate))
 
+#define CK_TYPE_PARAMETER_STRUCT (dbus_g_type_get_struct ("GValueArray", \
+                                                          G_TYPE_STRING, \
+                                                          G_TYPE_VALUE, \
+                                                          G_TYPE_INVALID))
+
 #define CK_SEAT_DIR          SYSCONFDIR "/ConsoleKit/seats.d"
 #define LOG_FILE             LOCALSTATEDIR "/log/ConsoleKit/history"
 #define CK_DBUS_PATH         "/org/freedesktop/ConsoleKit"
 #define CK_MANAGER_DBUS_PATH CK_DBUS_PATH "/Manager"
 #define CK_MANAGER_DBUS_NAME "org.freedesktop.ConsoleKit.Manager"
 
+#define IS_STR_SET(x) (x != NULL && x[0] != '\0')
+
 struct CkManagerPrivate
 {
 #ifdef HAVE_POLKIT
@@ -391,6 +403,7 @@ log_seat_added_event (CkManager  *manage
         GError            *error;
         char              *sid;
         CkSeatKind         seat_kind;
+        char              *seat_type;
 
         memset (&event, 0, sizeof (CkLogEvent));
 
@@ -400,9 +413,11 @@ log_seat_added_event (CkManager  *manage
         sid = NULL;
         ck_seat_get_id (seat, &sid, NULL);
         ck_seat_get_kind (seat, &seat_kind, NULL);
+        ck_seat_get_type_string (seat, &seat_type, NULL);
 
         event.event.seat_added.seat_id = (char *)get_object_id_basename (sid);
         event.event.seat_added.seat_kind = (int)seat_kind;
+        event.event.seat_added.seat_type = (char *)seat_type;
 
         error = NULL;
         res = ck_event_logger_queue_event (manager->priv->logger, &event, &error);
@@ -412,6 +427,7 @@ log_seat_added_event (CkManager  *manage
         }
 
         g_free (sid);
+        g_free (seat_type);
 }
 
 static void
@@ -516,6 +532,7 @@ log_seat_session_added_event (CkManager 
         if (session != NULL) {
                 g_object_get (session,
                               "session-type", &event.event.seat_session_added.session_type,
+                              "display-type", &event.event.seat_session_added.display_type,
                               "x11-display", &event.event.seat_session_added.session_x11_display,
                               "x11-display-device", &event.event.seat_session_added.session_x11_display_device,
                               "display-device", &event.event.seat_session_added.session_display_device,
@@ -571,6 +588,7 @@ log_seat_session_removed_event (CkManage
         if (session != NULL) {
                 g_object_get (session,
                               "session-type", &event.event.seat_session_removed.session_type,
+                              "display-type", &event.event.seat_session_removed.display_type,
                               "x11-display", &event.event.seat_session_removed.session_x11_display,
                               "x11-display-device", &event.event.seat_session_removed.session_x11_display_device,
                               "display-device", &event.event.seat_session_removed.session_display_device,
@@ -844,6 +862,8 @@ ready_cb (PolkitAuthority *authority,
         PolkitAuthorizationResult *ret;
         GError *error;
 
+        g_debug ("CkManager: Ready.");
+
         error = NULL;
         ret = polkit_authority_check_authorization_finish (authority, res, &error);
         if (error != NULL) {
@@ -974,6 +994,7 @@ session_is_real_user (CkSession *session
 
         /* filter out GDM user */
         if (username != NULL && strcmp (username, "gdm") == 0) {
+                g_debug ("CkManager: Session is not real user");
                 ret = FALSE;
                 goto out;
         }
@@ -982,6 +1003,7 @@ session_is_real_user (CkSession *session
                 *userp = g_strdup (username);
         }
 
+        g_debug ("CkManager: Session is real user");
         ret = TRUE;
 
  out:
@@ -1242,6 +1264,7 @@ on_seat_active_session_changed_full (CkS
 {
         char *ssid = NULL;
 
+        g_debug ("CkManager: Active session changed.");
         if (session != NULL) {
                 ck_session_get_id (session, &ssid, NULL);
         }
@@ -1261,6 +1284,7 @@ on_seat_session_added_full (CkSeat     *
 {
         char *ssid = NULL;
 
+        g_debug ("CkManager: Session added.");
         ck_session_get_id (session, &ssid, NULL);
 
         ck_manager_dump (manager);
@@ -1278,6 +1302,7 @@ on_seat_session_removed_full (CkSeat    
 {
         char *ssid = NULL;
 
+        g_debug ("CkManager: Seat Session removed.");
         ck_session_get_id (session, &ssid, NULL);
 
         ck_manager_dump (manager);
@@ -1293,6 +1318,7 @@ on_seat_device_added (CkSeat      *seat,
                       GValueArray *device,
                       CkManager   *manager)
 {
+        g_debug ("CkManager: Seat device added.");
         ck_manager_dump (manager);
         log_seat_device_added_event (manager, seat, device);
 }
@@ -1302,6 +1328,7 @@ on_seat_device_removed (CkSeat      *sea
                         GValueArray *device,
                         CkManager   *manager)
 {
+        g_debug ("CkManager: Seat device removed.");
         ck_manager_dump (manager);
         log_seat_device_removed_event (manager, seat, device);
 }
@@ -1329,15 +1356,23 @@ disconnect_seat_signals (CkManager *mana
 }
 
 static CkSeat *
-add_new_seat (CkManager *manager,
-              CkSeatKind kind)
+add_new_seat (CkManager  *manager,
+              const char *give_sid,
+              CkSeatKind  kind,
+              const char *type)
 {
         char   *sid;
         CkSeat *seat;
 
-        sid = generate_seat_id (manager);
+        if (IS_STR_SET (give_sid)) {
+                sid = g_strdup (give_sid);
+        } else {
+                sid = generate_seat_id (manager);
+        }
+
+        g_debug ("CkManager: Add new seat '%s'.", sid);
 
-        seat = ck_seat_new (sid, kind);
+        seat = ck_seat_new (sid, kind, type);
 
         /* First we connect our own signals to the seat, followed by
          * the D-Bus signal hookup to make sure we can first dump the
@@ -1362,7 +1397,7 @@ add_new_seat (CkManager *manager,
         ck_seat_run_programs (seat, NULL, NULL, "seat_added");
 
         g_debug ("Emitting seat-added: %s", sid);
-        g_signal_emit (manager, signals [SEAT_ADDED], 0, sid);
+        g_signal_emit (manager, signals [SEAT_ADDED], 0, sid, type);
 
         log_seat_added_event (manager, seat);
 
@@ -1381,6 +1416,8 @@ remove_seat (CkManager *manager,
         sid = NULL;
         ck_seat_get_id (seat, &sid, NULL);
 
+        g_debug ("CkManager: Remove seat '%s'", sid);
+
         /* Need to get the original key/value */
         res = g_hash_table_lookup_extended (manager->priv->seats,
                                             sid,
@@ -1420,64 +1457,22 @@ remove_seat (CkManager *manager,
         g_free (sid);
 }
 
-#define IS_STR_SET(x) (x != NULL && x[0] != '\0')
-
 static CkSeat *
 find_seat_for_session (CkManager *manager,
                        CkSession *session)
 {
         CkSeat  *seat;
-        gboolean is_static_x11;
-        gboolean is_static_text;
-        char    *display_device;
-        char    *x11_display_device;
-        char    *x11_display;
-        char    *remote_host_name;
-        gboolean is_local;
-
-        is_static_text = FALSE;
-        is_static_x11 = FALSE;
-
-        seat = NULL;
-        display_device = NULL;
-        x11_display_device = NULL;
-        x11_display = NULL;
-        remote_host_name = NULL;
-        is_local = FALSE;
-
-        /* FIXME: use matching to group entries? */
-
-        ck_session_get_display_device (session, &display_device, NULL);
-        ck_session_get_x11_display_device (session, &x11_display_device, NULL);
-        ck_session_get_x11_display (session, &x11_display, NULL);
-        ck_session_get_remote_host_name (session, &remote_host_name, NULL);
-        ck_session_is_local (session, &is_local, NULL);
-
-        if (IS_STR_SET (x11_display)
-            && IS_STR_SET (x11_display_device)
-            && ! IS_STR_SET (remote_host_name)
-            && is_local == TRUE) {
-                is_static_x11 = TRUE;
-        } else if (! IS_STR_SET (x11_display)
-                   && ! IS_STR_SET (x11_display_device)
-                   && IS_STR_SET (display_device)
-                   && ! IS_STR_SET (remote_host_name)
-                   && is_local == TRUE) {
-                is_static_text = TRUE;
-        }
+        char    *sid = NULL;
+
+        ck_session_get_seat_id (session, &sid, NULL);
 
-        if (is_static_x11 || is_static_text) {
-                char *sid;
+        if (! IS_STR_SET (sid)) {
                 sid = g_strdup_printf ("%s/Seat%u", CK_DBUS_PATH, 1);
-                seat = g_hash_table_lookup (manager->priv->seats, sid);
-                g_free (sid);
         }
 
-        g_free (display_device);
-        g_free (x11_display_device);
-        g_free (x11_display);
-        g_free (remote_host_name);
+        seat = g_hash_table_lookup (manager->priv->seats, sid);
 
+        g_free (sid);
         return seat;
 }
 
@@ -1612,36 +1607,52 @@ open_session_for_leader (CkManager      
         CkSession   *session;
         CkSeat      *seat;
         const char  *ssid;
+        char        *sid;
         const char  *cookie;
 
+        g_debug ("CkManager: Open session for leader.");
         ssid = ck_session_leader_peek_session_id (leader);
         cookie = ck_session_leader_peek_cookie (leader);
 
-        session = ck_session_new_with_parameters (ssid,
-                                                  cookie,
-                                                  parameters);
+        session = g_hash_table_lookup (manager->priv->sessions, ssid);
 
         if (session == NULL) {
-                GError *error;
-                g_debug ("Unable to create new session");
-                error = g_error_new (CK_MANAGER_ERROR,
-                                     CK_MANAGER_ERROR_GENERAL,
-                                     "Unable to create new session");
-                dbus_g_method_return_error (context, error);
-                g_error_free (error);
+                g_debug ("CkManager: Creating new session.");
+                session = ck_session_new_with_parameters (ssid,
+                                                          parameters);
+
+                if (session == NULL) {
+                        GError *error;
+                        g_debug ("CkManager: Unable to create new session");
+                        error = g_error_new (CK_MANAGER_ERROR,
+                                             CK_MANAGER_ERROR_GENERAL,
+                                             "Unable to create new session");
+                        dbus_g_method_return_error (context, error);
+                        g_error_free (error);
 
-                return;
+                        return;
+                }
+
+                g_hash_table_insert (manager->priv->sessions,
+                                     g_strdup (ssid),
+                                     g_object_ref (session));
+
+        } else {
+                g_debug ("CkManager: Using found session.");
+                ck_session_set_parameters (session, parameters);
         }
 
-        g_hash_table_insert (manager->priv->sessions,
-                             g_strdup (ssid),
-                             g_object_ref (session));
+        ck_session_set_cookie (session, cookie, NULL);
+        ck_session_set_is_open (session, TRUE, NULL);
 
         /* Add to seat */
         seat = find_seat_for_session (manager, session);
         if (seat == NULL) {
+                sid = NULL;
+                ck_session_get_seat_id (session, &sid, NULL);
                 /* create a new seat */
-                seat = add_new_seat (manager, CK_SEAT_KIND_DYNAMIC);
+                seat = add_new_seat (manager, sid, CK_SEAT_KIND_DYNAMIC, "Default");
+                g_free (sid);
         }
 
         ck_seat_add_session (seat, session, NULL);
@@ -1863,6 +1874,7 @@ generate_session_for_leader (CkManager  
 {
         gboolean res;
 
+        g_debug ("CkManager: Generate session for leader.");
         res = ck_session_leader_collect_parameters (leader,
                                                     context,
                                                     (CkSessionLeaderDoneFunc)collect_parameters_cb,
@@ -1877,11 +1889,57 @@ generate_session_for_leader (CkManager  
         }
 }
 
+static char *
+check_parameters_for_ssid (const GPtrArray *parameters)
+{
+        int i;
+
+        if (parameters == NULL) {
+                return NULL;
+        }
+
+        for (i = 0; i < parameters->len; i++) {
+                GValue   val_struct = { 0, };
+                char    *prop_name;
+                gboolean res;
+
+                g_value_init (&val_struct, CK_TYPE_PARAMETER_STRUCT);
+                g_value_set_static_boxed (&val_struct, g_ptr_array_index (parameters, i));
+
+                res = dbus_g_type_struct_get (&val_struct,
+                                              0, &prop_name,
+                                              G_MAXUINT);
+                if (! res) {
+                        g_debug ("CkManager: Unable to read parameter name");
+                        continue;
+                }
+
+                if (prop_name != NULL && strcmp (prop_name, "session") == 0) {
+                        GValue   prop_val = { 0, };
+                        GValue  *session_val;
+
+                        g_value_init (&prop_val, G_TYPE_VALUE);
+                        res = dbus_g_type_struct_get_member (&val_struct, 1, &prop_val);
+
+                        if (! res) {
+                                g_debug ("CkManager: Unable to read parameter value");
+                                continue;
+                        }
+
+                        session_val = g_value_get_boxed (&prop_val);
+
+                        return g_value_dup_string (session_val);
+                }
+        }
+
+        return NULL;
+}
+
 static gboolean
-create_session_for_sender (CkManager             *manager,
-                           const char            *sender,
-                           const GPtrArray       *parameters,
-                           DBusGMethodInvocation *context)
+open_session_for_sender (CkManager             *manager,
+                         const char            *sender,
+                         const GPtrArray       *parameters,
+                         DBusGMethodInvocation *context)
 {
         pid_t           pid;
         uid_t           uid;
@@ -1889,6 +1947,7 @@ create_session_for_sender (CkManager    
         char            *cookie;
         char            *ssid;
         CkSessionLeader *leader;
+        CkSession       *session;
 
         g_debug ("CkManager: create session for sender: %s", sender);
 
@@ -1907,9 +1966,21 @@ create_session_for_sender (CkManager    
         }
 
         cookie = generate_session_cookie (manager);
-        ssid = generate_session_id (manager);
 
-        g_debug ("Creating new session ssid: %s", ssid);
+        ssid = check_parameters_for_ssid (parameters);
+
+        if (IS_STR_SET (ssid)) {
+                session = g_hash_table_lookup (manager->priv->sessions, ssid);
+
+                /* FIXME: Need to verify that the session belongs to a seat
+                 * managed by the sender
+                 */
+                g_debug ("CkManager: Managing existing session ssid: %s", ssid);
+        } else {
+                ssid = generate_session_id (manager);
+                session = NULL;
+                g_debug ("CkManager: Creating new session ssid: %s", ssid);
+        }
 
         leader = ck_session_leader_new ();
         ck_session_leader_set_uid (leader, uid);
@@ -2148,7 +2219,7 @@ ck_manager_open_session (CkManager      
         gboolean ret;
 
         sender = dbus_g_method_get_sender (context);
-        ret = create_session_for_sender (manager, sender, NULL, context);
+        ret = open_session_for_sender (manager, sender, NULL, context);
         g_free (sender);
 
         return ret;
@@ -2163,7 +2234,7 @@ ck_manager_open_session_with_parameters 
         gboolean ret;
 
         sender = dbus_g_method_get_sender (context);
-        ret = create_session_for_sender (manager, sender, parameters, context);
+        ret = open_session_for_sender (manager, sender, parameters, context);
         g_free (sender);
 
         return ret;
@@ -2180,10 +2251,12 @@ remove_session_for_cookie (CkManager  *m
         char            *sid;
         gboolean         res;
         gboolean         ret;
+        gboolean         should_remove_session;
 
         ret = FALSE;
         orig_ssid = NULL;
         orig_session = NULL;
+        should_remove_session = FALSE;
 
         g_debug ("Removing session for cookie: %s", cookie);
 
@@ -2210,6 +2283,17 @@ remove_session_for_cookie (CkManager  *m
                 goto out;
         }
 
+        ck_session_set_is_open (orig_session, FALSE, NULL);
+        ck_session_set_cookie (orig_session, NULL, NULL);
+        ck_session_set_active (orig_session, FALSE, NULL);
+        ck_session_set_unix_user (orig_session, 0, NULL);
+        ck_session_set_x11_display (orig_session, NULL, NULL);
+        ck_session_set_x11_display_device (orig_session, NULL, NULL);
+        ck_session_set_display_device (orig_session, NULL, NULL);
+        ck_session_set_login_session_id (orig_session, NULL, NULL);
+        ck_session_set_remote_host_name (orig_session, NULL, NULL);
+        ck_session_set_under_request (orig_session, FALSE, NULL);
+
         /* Must keep a reference to the session in the manager until
          * all events for seats are cleared.  So don't remove
          * or steal the session from the master list until
@@ -2217,31 +2301,33 @@ remove_session_for_cookie (CkManager  *m
          * for seat removals doesn't work.
          */
 
-        /* remove from seat */
-        sid = NULL;
-        ck_session_get_seat_id (orig_session, &sid, NULL);
-        if (sid != NULL) {
-                CkSeat *seat;
-                seat = g_hash_table_lookup (manager->priv->seats, sid);
-                if (seat != NULL) {
-                        CkSeatKind kind;
-
-                        ck_seat_remove_session (seat, orig_session, NULL);
-
-                        kind = CK_SEAT_KIND_STATIC;
-                        /* if dynamic seat has no sessions then remove it */
-                        ck_seat_get_kind (seat, &kind, NULL);
-                        if (kind == CK_SEAT_KIND_DYNAMIC) {
-                                remove_seat (manager, seat);
+        ck_session_get_remove_on_close (orig_session, &should_remove_session, NULL);
+
+        if (should_remove_session) {
+                /* remove from seat */
+                g_debug ("CkManager: Should remove session");
+                sid = NULL;
+                ck_session_get_seat_id (orig_session, &sid, NULL);
+                if (sid != NULL) {
+                        CkSeat *seat;
+                        seat = g_hash_table_lookup (manager->priv->seats, sid);
+                        if (seat != NULL) {
+                                CkSeatKind kind;
+
+                                ck_seat_remove_session (seat, orig_session, NULL);
+
+                                kind = CK_SEAT_KIND_STATIC;
+                                /* if dynamic seat has no sessions then remove it */
+                                ck_seat_get_kind (seat, &kind, NULL);
                         }
                 }
-        }
-        g_free (sid);
+                g_free (sid);
 
-        /* Remove the session from the list but don't call
-         * unref until we are done with it */
-        g_hash_table_steal (manager->priv->sessions,
-                            ck_session_leader_peek_session_id (leader));
+                /* Remove the session from the list but don't call
+                 * unref until we are done with it */
+                g_hash_table_steal (manager->priv->sessions,
+                                    ck_session_leader_peek_session_id (leader));
+        }
 
         ck_manager_dump (manager);
 
@@ -2249,11 +2335,13 @@ remove_session_for_cookie (CkManager  *m
 
         ret = TRUE;
  out:
-        if (orig_session != NULL) {
-                g_object_unref (orig_session);
-        }
-        g_free (orig_ssid);
+        if (should_remove_session) {
+                if (orig_session != NULL) {
+                        g_object_unref (orig_session);
+                }
 
+                g_free (orig_ssid);
+        }
         return ret;
 }
 
@@ -2374,6 +2462,7 @@ remove_leader_for_connection (const char
         g_assert (leader != NULL);
         g_assert (data->service_name != NULL);
 
+        g_debug ("CkManager: Remove leader for connection");
         name = ck_session_leader_peek_service_name (leader);
         if (strcmp (name, data->service_name) == 0) {
                 remove_session_for_cookie (data->manager, cookie, NULL);
@@ -2391,6 +2480,8 @@ remove_sessions_for_connection (CkManage
         guint            n_removed;
         RemoveLeaderData data;
 
+        g_debug ("CkManager: Remove sessions for connection");
+
         data.service_name = service_name;
         data.manager = manager;
 
@@ -2426,6 +2517,8 @@ register_manager (CkManager *manager)
         manager->priv->pol_ctx = polkit_authority_get ();
 #endif
 
+        g_debug ("CkManager: Registering manager");
+
         error = NULL;
         manager->priv->connection = dbus_g_bus_get (DBUS_BUS_SYSTEM, &error);
         if (manager->priv->connection == NULL) {
@@ -2471,9 +2564,11 @@ ck_manager_class_init (CkManagerClass *k
                               G_STRUCT_OFFSET (CkManagerClass, seat_added),
                               NULL,
                               NULL,
-                              g_cclosure_marshal_VOID__BOXED,
+                              ck_marshal_VOID__STRING_STRING,
                               G_TYPE_NONE,
-                              1, DBUS_TYPE_G_OBJECT_PATH);
+                              2,
+                              G_TYPE_STRING,
+                              G_TYPE_STRING);
         signals [SEAT_REMOVED] =
                 g_signal_new ("seat-removed",
                               G_TYPE_FROM_CLASS (object_class),
@@ -2580,6 +2675,43 @@ ck_manager_get_seats (CkManager  *manage
 }
 
 static void
+listify_unmanaged_seat_ids (char       *id,
+                            CkSeat     *seat,
+                            GPtrArray **array)
+{
+        if (ck_seat_is_managed (seat)) {
+                return;
+        }
+
+        g_ptr_array_add (*array, g_strdup (id));
+}
+
+
+/*
+  Example:
+  dbus-send --system --dest=org.freedesktop.ConsoleKit \
+  --type=method_call --print-reply --reply-timeout=2000 \
+  /org/freedesktop/ConsoleKit/Manager \
+  org.freedesktop.ConsoleKit.Manager.GetUnmanagedSeats
+*/
+gboolean
+ck_manager_get_unmanaged_seats (CkManager  *manager,
+                                GPtrArray **seats,
+                                GError    **error)
+{
+        g_return_val_if_fail (CK_IS_MANAGER (manager), FALSE);
+
+        if (seats == NULL) {
+                return FALSE;
+        }
+
+        *seats = g_ptr_array_new ();
+        g_hash_table_foreach (manager->priv->seats, (GHFunc)listify_unmanaged_seat_ids, seats);
+
+        return TRUE;
+}
+
+static void
 listify_session_ids (char       *id,
                      CkSession  *session,
                      GPtrArray **array)
